# -*- coding: utf-8 -*-
# Generated by Django 1.11.14 on 2020-02-28 20:52
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations


FIELDS = (
    ('informationdesk', 'nom', 'name'),
    ('touristiccontent', 'nom', 'name'),
    ('touristiccontent', 'chapeau', 'description_teaser'),
    ('touristiccontent', 'infos_pratiques', 'practical_info'),
    ('touristiccontent', 'public', 'published'),
    ('touristiccontentcategory', 'nom', 'label'),
    ('touristiccontentcategory', 'label_type1', 'type1_label'),
    ('touristiccontentcategory', 'label_type2', 'type2_label'),
    ('touristiccontenttype', 'nom', 'label'),
    ('touristicevent', 'nom', 'name'),
    ('touristicevent', 'chapeau', 'description_teaser'),
    ('touristicevent', 'point_rdv', 'meeting_point'),
    ('touristicevent', 'accessibilite', 'accessibility'),
    ('touristicevent', 'reservation', 'booking'),
    ('touristicevent', 'infos_pratiques', 'practical_info'),
    ('touristicevent', 'public_vise', 'target_audience'),
    ('touristicevent', 'public', 'published'),
)


def forward(apps, schema_editor):
    with schema_editor.connection.cursor() as cursor:
        for lang in settings.MODELTRANSLATION_LANGUAGES:
            for model, old, new in FIELDS:
                cursor.execute(
                    "SELECT 1 FROM information_schema.columns WHERE table_name='tourism_{}' AND column_name='{}_{}'".format(model, old, lang)
                )
                if cursor.fetchone():
                    cursor.execute('ALTER TABLE tourism_{} RENAME {}_{} TO {}_{}'.format(model, old, lang, new, lang))


class Migration(migrations.Migration):

    dependencies = [
        ('tourism', '0009_auto_20200228_1755'),
    ]

    operations = [
        migrations.RunPython(forward),
    ]
